unit ufmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Windows, Forms, Controls, Graphics, Dialogs, ComCtrls, ExtCtrls,
  StdCtrls, Buttons, Grids, Menus, Translations, VirtualTrees, uTypes, ActiveX;

type

  tFnMode = (fnmElement,fnmKey);

  PAnwendungData = ^TAnwendungData;
  TAnwendungData = record
     Element   : String;
     Relevant  : String;
     Typ       : String;
  end;

  PSMData = ^TSMData;
  TSMData = record
     Key_Vater   : String;  { Key Vater-Element                                 }
     Key_Kind    : String;  { Key Kind-Element                                  }
     Bezeichnung : String;  { Bezeichnung Kind-Element                          }
     Groups      : TStringArray;
  end;


  { TfMain }

  TfMain = class(TForm)
    BitBtn1: TBitBtn;
    cbSmGroups: TComboBox;
    EdSmElement: TEdit;
    gbBasisImport: TGroupBox;
    imgSmStateTrue: TImage;
    ImageList1: TImageList;
    imgSmStateFalse: TImage;
    Label5: TLabel;
    lblSmElement: TLabel;
    lblSmGroup: TLabel;
    lbSmDimension: TListBox;
    pmSmInfo: TMenuItem;
    pmSmNode: TMenuItem;
    pmSmChild: TMenuItem;
    Panel11: TPanel;
    Panel14: TPanel;
    pbSM: TProgressBar;
    pmSM: TPopupMenu;
    pSmHeaderCol: TPanel;
    pSmHeaderRow: TPanel;
    pSmFunction: TPanel;
    pSM: TPanel;
    Splitter7: TSplitter;
    lv: TListView;
    pcRegister: TPageControl;
    pb: TProgressBar;
    pTop: TPanel;
    sb: TStatusBar;
    tsSecManagement: TTabSheet;
    tsSystem: TTabSheet;
    vstSM: TVirtualStringTree;
    procedure cbSmGroupsKeyPress(Sender: TObject; var Key: char);
    procedure cbSmGroupsEditingDone(Sender: TObject);
    procedure cbSmGroupsSelect(Sender: TObject);

    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lvColumnClick(Sender: TObject; Column: TListColumn);
    procedure lvCompare(Sender: TObject; Item1, Item2: TListItem;Data: Integer; var Compare: Integer);
    procedure pmSmChildClick(Sender: TObject);
    procedure pmSmNodeClick(Sender: TObject);
    procedure pmSMPopup(Sender: TObject);
    procedure pSmHeaderColPaint(Sender: TObject);
    procedure pSmHeaderRowPaint(Sender: TObject);
    procedure pSMResize(Sender: TObject);
    procedure tsSecManagementShow(Sender: TObject);

    procedure vstSMDragDrop(Sender: TBaseVirtualTree; Source: TObject;
      DataObject: IDataObject; Formats: TFormatArray; Shift: TShiftState;
      const Pt: TPoint; var Effect: LongWord; Mode: TDropMode);
    procedure vstSMDragOver(Sender: TBaseVirtualTree; Source: TObject;
      Shift: TShiftState; State: TDragState; const Pt: TPoint; Mode: TDropMode;
      var Effect: LongWord; var Accept: Boolean);
    procedure vstSMFreeNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
    procedure vstSMGetNodeDataSize(Sender: TBaseVirtualTree;
      var NodeDataSize: Integer);
    procedure vstSMGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType; var CellText: String);
    procedure vstSMInitNode(Sender: TBaseVirtualTree; ParentNode,
      Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
    procedure vstSMNewText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; const NewText: String);

  private
    { Standard-Liste füllen }

    { SecurityManagement }
    procedure FillcbSmAnwendung(Locate: String);

    Procedure PaintSmPanel(tp: TPanel; RowHeader: String; ColHeader: String; pbVisible: Boolean);
    Procedure CreateVstSM(sRow: String; sCol: String);
    Procedure FillDataVstSM(sRow: String);
    Function  vstSMFindNode(s : String; StartNode: PVirtualNode): PVirtualNode;
  public
    boSmChanged : Boolean;
  end;

var
  fMain: TfMain;

  ColumnToSort: Integer;
  LastSorted: Integer;
  SortDir: Integer;


implementation

uses ulGroups, ulElements, ulElementSecurity;

{$R *.lfm}

{ TfMain }

procedure TfMain.FormCreate(Sender: TObject);
var PODirectory: String;
begin
  PODirectory := Application.Location + 'languages' + DirectorySeparator;
  TranslateUnitResourceStrings('LCLStrConsts', PODirectory + 'lclstrconsts.%s.po', 'de', '');
  If FileExists(fPathProg + ulGroups.GroupFileStream) then lGroups.LoadFromStream else lGroups.LoadFromCSV;
  boSmChanged := False;
end;



// -------------- SecurityManagement ---------------------------------------------------

procedure TfMain.vstSMDragDrop(Sender: TBaseVirtualTree; Source: TObject;
  DataObject: IDataObject; Formats: TFormatArray; Shift: TShiftState;
  const Pt: TPoint; var Effect: LongWord; Mode: TDropMode);
begin
  PaintSmPanel(pSM,TListbox(Source).Items[TlistBox(Source).ItemIndex],'Goups',True);
  lElementSecurity.CreateFromCSV(TListbox(Source).Items[TlistBox(Source).ItemIndex]);

  { hier die Funktion 2 mal aufgerufen, damit es einmal klappt }
//  CreateVstSM(TListbox(Source).Items[TlistBox(Source).ItemIndex],'Goups');
  CreateVstSM(TListbox(Source).Items[TlistBox(Source).ItemIndex],'Goups');

  boSmChanged := False;
  PaintSmPanel(pSM,'-1','-1',False);
  pSmFunction.Visible := (vstSM.RootNodeCount > 0);
end;


Procedure TfMain.CreateVstSM(sRow: String; sCol: String);
var i, iCol, iIndex : Integer;
    vtc : TVirtualTreeColumn;
    Data : PSMData;
    XNode: PVirtualNode;
    sVater, sKind, sBezeichnung, sHeader : String;
begin
  vstSM.Clear;
  vstSM.Header.Columns.Clear;
  cbSmGroups.Clear;

  lElements.LoadFromCSV(sRow);
  lElements.SortBy(tleLevelAsc);
  lGroups.SortBy(tlgKindAsc);

  pbSM.Min:=0;
  pbSM.Max:=lElements.Count-1;
  pbSM.Refresh;

  vstSM.BeginUpdate;
  { erstmal alle Spalten in der VST erzeugen, die ich benötige }
  for i := 0 to lGroups.Count do vtc := vstSM.Header.Columns.Add;

  // erste Spalte erhält die Überschrift der Nodes. Beispiel: Kostenarten-Hierarchie (sRow)
  vstSM.Header.Columns[0].Style := vsText;
  vstSM.Header.Columns[0].Options := [coAllowClick,coAllowFocus,coEnabled,coParentBidiMode,coResizable,coSmartResize,coShowDropMark,coVisible,coFixed,coUseCaptionAlignment];
  vstSM.Header.Columns[0].Width:=300;
  vstSM.Header.Columns[0].Text := sRow;
  vstSM.Header.Columns[0].Tag  := i;
  vstSM.Header.Columns[0].CaptionAlignment:=taLeftJustify;

  // in alle weiteren Spalten werden die Benutzergruppen angelegt (sCol)
  for i := 0 to lGroups.Count-1 do
   begin
     vstSM.Header.Columns[i+1].Style := vsText;
     vstSM.Header.Columns[i+1].Options := [coAllowClick,coAllowFocus,coEnabled,coParentBidiMode,coResizable,coSmartResize,coShowDropMark,coVisible,coUseCaptionAlignment];
     vstSM.Header.Columns[i+1].Width:=100;
     vstSM.Header.Columns[i+1].Text := lGroups.Items[i].Name_Kind;
     vstSM.Header.Columns[i+1].Tag  := i;
     vstSM.Header.Columns[i+1].CaptionAlignment:=taCenter;
     cbSmGroups.Items.Add(lGroups.Items[i].Name_Kind);
   end;
   vstSM.Header.Options := [hoAutoResize,hoColumnResize,hoDblClickResize,hoVisible];
   vstSM.Refresh;

   {jetzt die Hierarchie in der ersten Spalte aufbauen}
   for i := 0 to lElements.Count - 1 do
   begin
     pbSM.Position := i;
     sVater       := lElements.Items[i].Key_Vater;
     sKind        := lElements.Items[i].Key_Kind;
     sBezeichnung := lElements.Items[i].Bezeichnung;
     if sBezeichnung = '' then sBezeichnung := sKind;
     if sVater <> sKind then
     begin
       XNode := vstSMFindNode(sVater,vstSM.GetFirst);
       XNode := vstSM.Addchild(XNode);
     end
     else
       XNode:=vstSM.AddChild(nil);
     if xNode <> NIL then
     begin
       Data := vstSM.GetNodeData(XNode);
       vstSM.ValidateNode(XNode,false);
       if Assigned(Data) then
       begin
          Data^.Bezeichnung := sBezeichnung;
          Data^.Key_Vater   := sVater;
          Data^.Key_Kind    := sKind;
          setLength(Data^.Groups,lGroups.Count);

{         ausgeklammert, u Platz zu sparen
          for iCol := 1 to vstSM.Header.Columns.Count-1 do
          begin
            sHeader := vstSM.Header.Columns[iCol].Text;
            iIndex := lElementSecurity.BinarySearch(sKind + sHeader);
            if iIndex > -1 then Data^.Groups[iCol] := lElementSecurity.Items[iIndex].Right;
          end;
}
       end;
     end;
   end;
   vstSM.EndUpdate;
   vstSM.Refresh;
   pbSM.Visible:=False;
end;

procedure TfMain.vstSMDragOver(Sender: TBaseVirtualTree; Source: TObject;
  Shift: TShiftState; State: TDragState; const Pt: TPoint; Mode: TDropMode;
  var Effect: LongWord; var Accept: Boolean);
begin
  if  Source = lbSmDimension then Accept := true
  else                            Accept := False;
end;

procedure TfMain.tsSecManagementShow(Sender: TObject);
begin
  PaintSmPanel(pSM,'-1','-1',False);
  FillcbSmAnwendung('');
  if vstSM.RootNodeCount = 0 then
  begin
    pSmFunction.Visible := (vstSM.RootNodeCount > 0);
    pSmHeaderRow.Caption := 'Ablage Hierarchie';
    pSmHeaderCol.Caption := 'Ablage Berechtigungsgruppen';
  end;
end;

procedure TfMain.FillcbSmAnwendung(Locate: String);
var i: Integer;
begin
  PaintSmPanel(pSM,'Hierarchie','Groups',False);
  lbSmDimension.Clear;
  lbSmDimension.Items.Add('zb_Leistungsstelle');
end;

procedure TfMain.vstSMFreeNode(Sender: TBaseVirtualTree; Node: PVirtualNode);
var Data : PSMData;
begin
  Data := vstSM.GetNodeData(Node);
  if Assigned(Data) then
  begin
    FillChar(Data^,Sizeof(TSMData),0);
    SetLength(Data^.Groups,0);
    Data^.Groups := NIL;
  end;
end;

procedure TfMain.vstSMGetNodeDataSize(Sender: TBaseVirtualTree;
  var NodeDataSize: Integer);
begin
  vstSM.NodeDataSize:=SizeOf(TSMData);
end;

procedure TfMain.vstSMGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
  Column: TColumnIndex; TextType: TVSTTextType; var CellText: String);
var Data: PSMData;
begin
  Data := vstSM.GetNodeData(Node);
  if Column = 0 then
    CellText := Data^.Bezeichnung
  else
    CellText := Data^.Groups[Column];
end;

procedure TfMain.vstSMInitNode(Sender: TBaseVirtualTree; ParentNode,
  Node: PVirtualNode; var InitialStates: TVirtualNodeInitStates);
var Data : PSMData;
begin
  Data := vstSM.GetNodeData(Node);
  Data^.Key_Kind:='';
  Data^.Key_Vater:='';
  Data^.Bezeichnung:='';
  setLength(Data^.Groups,lGroups.Count);
  FillChar(Data^.Groups,SizeOf(Data^.Groups),0);
end;

procedure TfMain.vstSMNewText(Sender: TBaseVirtualTree; Node: PVirtualNode;
  Column: TColumnIndex; const NewText: String);
var Data: PSMData;
begin
  Data := vstSM.GetNodeData(Node);
  if Column = 0 then
     Data^.Bezeichnung := NewText;
//  else
//     Data^.Groups[Column] := NewText;
end;

Procedure TfMain.FillDataVstSM(sRow: String);
var XNode: PVirtualNode;
    Data :  PSMData;
    iCol : Integer;
begin
  lElementSecurity.LoadFromStream(sRow);
  XNode := vstSM.GetFirst;
  while XNode <> NIL do
  begin
    Data := vstSM.GetNodeData(XNode);

    xNode := vstSM.GetNext(XNode);
  end;
end;

Function  TfMain.vstSMFindNode(s : String;StartNode: PVirtualNode): PVirtualNode;
var XNode: PVirtualNode;
    Data:  PSMData;
begin
  XNode:= StartNode;
  while XNode <> nil do
  begin
    Data := vstSM.GetNodeData(XNode);
    if Data^.Key_Kind = s then Break;
    xNode := vstSM.GetNext(XNode);
  end;
  result := XNode
end;

Procedure TfMain.PaintSmPanel(tp: TPanel; RowHeader: String; ColHeader: String; pbVisible: Boolean);
var w, h, s: Integer;
begin
  w := tp.Width;
  h := tp.Height;
  s  := 2;

  pbSM.Visible := pbVisible;

  pSmHeaderCol.Top    := 0;
  pSmHeaderCol.Height := 21;
  pSmHeaderCol.Left   := pSmHeaderCol.Height;
  pSmHeaderCol.Width  := w - pSmHeaderCol.Left - s;

  pSmHeaderRow.Top    := pSmHeaderCol.Height - s;
  pSmHeaderRow.Left   := 0;
  pSmHeaderRow.Height := h - pSmHeaderRow.Top;
  pSmHeaderRow.Width  := 21;

  if pbSM.Visible then pSmHeaderRow.Height := pSmHeaderRow.Height - pbSM.Height;

  vstSM.Top    := pSmHeaderCol.Height + s;
  vstSM.Left   := pSmHeaderRow.Width + s;
  vstSM.Height := h - pSmHeaderCol.Height - s;
  vstSM.Width  := w - pSmHeaderRow.Width - s;

  if RowHeader <> '-1' then pSmHeaderRow.Caption := RowHeader;
  if ColHeader <> '-1' then pSmHeaderCol.Caption := ColHeader;

  if pbSM.Visible then
  begin
     pSmHeaderRow.Height := pSmHeaderRow.Height - pbSM.Height;
     vstSM.Height        := vstSM.Height - pbSM.Height;
  end;

  imgSmStateTrue.Visible := (boSmChanged = False);
  imgSmStateFalse.Visible := (boSmChanged = True);

  imgSmStateTrue.Repaint;
  vstSM.Repaint;
  pbSM.Repaint;
  pSmHeaderCol.Repaint;
  pSmHeaderRow.Repaint;

  tp.Repaint;

end;

procedure TfMain.pSMResize(Sender: TObject);
begin
  PaintSmPanel(pSM,'-1','-1',False);
end;

procedure TfMain.pSmHeaderColPaint(Sender: TObject);
begin
  lblSmGroup.Caption:=pSmHeaderCol.Caption;
end;

procedure TfMain.pSmHeaderRowPaint(Sender: TObject);
begin
  lblSmElement.Caption:=pSmHeaderRow.Caption;
end;

procedure TfMain.pmSMPopup(Sender: TObject);
var Data : PSMData;
    iCol : Integer;
    sValue : String;
begin
  if vstSM.FocusedNode <> NIL then
  begin
    Data := vstSM.GetNodeData(vstSM.FocusedNode);
    iCol := vstSM.FocusedColumn;
    sValue := Data^.Groups[vstSM.FocusedColumn];
    if sValue = '' then  pmSmInfo.Caption:= ' Write setzen für'
    else                 pmSmInfo.Caption:= sValue + ' löschen für';
    pmSmNode.Caption := 'Element ' + Data^.Bezeichnung;
    pmSmChild.Caption:= 'Hierarchie ' + Data^.Bezeichnung;
    pmSmChild.Enabled:= (vstSM.ChildCount[vstSM.FocusedNode] > 0);
  end;
end;

procedure TfMain.pmSmNodeClick(Sender: TObject);
var Data : PSMData;
begin
  Data := vstSM.GetNodeData(vstSM.FocusedNode);
  if Data^.Groups[vstSM.FocusedColumn] = 'WRITE' then Data^.Groups[vstSM.FocusedColumn] := ''
  else                                                Data^.Groups[vstSM.FocusedColumn] := 'WRITE';
  boSmChanged := True;
  PaintSmPanel(pSM,'-1','-1',False);
end;

procedure TfMain.pmSmChildClick(Sender: TObject);
var Data : PSMData;
    pNode, cNode: PVirtualNode;
    sValue : String;
begin
  pNode := vstSM.FocusedNode;
  Data := vstSM.GetNodeData(pNode);
  if Data^.Groups[vstSM.FocusedColumn] = 'WRITE' then sValue := ''
  else                                                sValue := 'WRITE';
  Data^.Groups[vstSM.FocusedColumn] := sValue;
  cNode := vstSM.GetFirstChild(pNode);
  while cNode <> NIL do
  begin
    if vstSM.GetNodeLevel(cNode) = vstSM.GetNodeLevel(pNode) then break;
    Data := vstSM.GetNodeData(cNode);
    Data^.Groups[vstSM.FocusedColumn] := sValue;
    cNode := vstSM.GetNext(cNode);
   end;
  boSmChanged := True;
  PaintSmPanel(pSM,'-1','-1',False);
end;

procedure TfMain.cbSmGroupsEditingDone(Sender: TObject);
var i : Integer;
    s : String;
begin
  cbSmGroups.DroppedDown:=False;
  for i := 1 to vstSm.Header.Columns.Count-2 do
  begin
    s := copy(vstSM.Header.Columns.Items[i].Text,1,length(cbSmGroups.Text));
    if s = cbSmGroups.Text then
    begin
       vstSm.ScrollIntoView(i,True);
       break;
    end;
  end;
end;

procedure TfMain.cbSmGroupsKeyPress(Sender: TObject; var Key: char);
var i : Integer;
    s: String;
begin
//  PostMessage(cbSmGroups.Handle, CB_SHOWDROPDOWN, 1, 0);
  SendMessage(cbSmGroups.Handle, CB_SHOWDROPDOWN, 1, 0);
  for i := 1 to vstSm.Header.Columns.Count-2 do
  begin
    s := copy(vstSM.Header.Columns.Items[i].Text,1,length(cbSmGroups.Text));
    if s = cbSmGroups.Text then
    begin
       vstSm.ScrollIntoView(i,True);
       break;
    end;
  end;
end;

procedure TfMain.cbSmGroupsSelect(Sender: TObject);
begin
    cbSmGroups.EditingDone;
end;


{ ----------------  Test-Installationen ---------------------------------------}


// ListView lv kann raus
procedure TfMain.BitBtn1Click(Sender: TObject);
var
tli : TListItem;  // löschen (lv)
i : Integer;      // löschen (lv)
begin
  lElements.LoadFromStream('zb_Leistungsstelle');
  lElements.SortBy(tleLevelAsc);
  // diesen Block später raus nehmen und Listview löschen
    lv.BeginUpdate;
    lv.Clear;
    For i := 0 to lElements.Count - 1 do
    begin
      tli := lv.Items.Add;
      tli.Caption := lElements.Items[i].Key_Vater;
      tli.SubItems.Add(lElements.Items[i].Key_Kind);
      tli.SubItems.Add(lElements.Items[i].Bezeichnung);
      tli.SubItems.Add(IntToStr(lElements.Items[i].Order));
      tli.SubItems.Add(IntToStr(lElements.Items[i].Level));
    end;
    lv.EndUpdate;
    pb.Position:=0;
end;

procedure TfMain.lvColumnClick(Sender: TObject; Column: TListColumn);
begin
  lv.BeginUpdate;
  ColumnToSort := Column.Index;
  if ColumnToSort = LastSorted then
    SortDir := 1 - SortDir
  else
    SortDir := 0;
  LastSorted := ColumnToSort;
  (Sender as TCustomListView).AlphaSort;
  lv.EndUpdate;
end;

procedure TfMain.lvCompare(Sender: TObject; Item1, Item2: TListItem;
  Data: Integer; var Compare: Integer);
var
  TempStr, TextToSort1, TextToSort2: String;
begin
//Texte zuweisen
  if ColumnToSort = 0 then
  begin
    TextToSort1 := Item1.Caption;
    TextToSort2 := Item2.Caption;
  end //if ColumnToSort = 0 then
  else
  begin
    TextToSort1 := Item1.SubItems[ColumnToSort - 1];
    TextToSort2 := Item2.SubItems[ColumnToSort - 1];
  end; //if ColumnToSort <> 0 then

//Je nach Sortierrichtung evtl. Texte vertauschen
  if SortDir <> 0 then
  begin
    TempStr := TextToSort1;
    TextToSort1 := TextToSort2;
    TextToSort2 := TempStr;
  end; //if SortDir <> 0 then

//Texte je nach Tag der Spalte unterschiedlich vergleichen
  case (Sender as TListView).Columns[ColumnToSort].Tag of
//Integer-Werte
    1: Compare := StrToIntDef(TextToSort1,0)-StrToIntDef(TextToSort2,0);
//Float-Werte
    2: begin
      Compare := 0;
      if StrToFloat(TextToSort1) > StrToFloat(TextToSort2) then
        Compare := Trunc(StrToFloat(TextToSort1)-StrToFloat(TextToSort2))+1;
      if StrToFloat(TextToSort1) < StrToFloat(TextToSort2) then
        Compare := Trunc(StrToFloat(TextToSort1)-StrToFloat(TextToSort2))-1;
    end; //2
//DateTime-Werte
    3: begin
      Compare := 0;
      if StrToDateTime(TextToSort1) > StrToDateTime(TextToSort2) then
        Compare := Trunc(StrToDateTime(TextToSort1)-StrToDateTime(TextToSort2))+1;
      if StrToDateTime(TextToSort1) < StrToDateTime(TextToSort2) then
        Compare := Trunc(StrToDateTime(TextToSort1)-StrToDateTime(TextToSort2))-1;
    end; //3
//Alles andere sind Strings
    else
      Compare := CompareText(TextToSort1,TextToSort2);
  end; //case (Sender as TListView).Columns[ColumnToSort].Tag of
end; //procedure TForm1.ListView1Compare



end.


